// itsnouse
freeslot("sfx_float")

sfxinfo[sfx_float] = {
	singular = false,
	caption = "Float Start."
}

addHook("AbilitySpecial", function(player)
	if not (player.pflags & PF_THOKKED)
	and player.mo.skin == "legacysilver"
		S_StartSound(player.mo, sfx_float)
	end
end)


addHook("PlayerThink", function(player)
	if not player and player.valid and player.mo.skin == "legacysilver" return end
	if player.spindown == nil
		player.spindown = 0
	end
	if not (player.cmd.buttons & BT_SPIN)
		player.spindown = 0
	end
	if player.cmd.buttons & BT_SPIN
	and player.mo.skin == "legacysilver"
	and player.mo.state ~= S_PLAY_MELEE
	and player.mo.state ~= S_PLAY_GLIDE_LANDING
	and player.spindown == 0
	and not (player.pflags & PF_SPINNING)
	and P_IsObjectOnGround(player.mo)
		S_StartSound(player.mo, sfx_zoom)
		player.mo.state = S_PLAY_MELEE
		player.pflags = $|PF_SPINNING
		P_InstaThrust(player.mo, player.mo.angle, 46*FRACUNIT)
		player.spindown = 1
	end
	if player.pflags & PF_SPINNING
	and player.mo.skin == "legacysilver"
		local slidedust = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, 0, MT_SPINDUST)
		slidedust.momx = P_RandomRange(-4, 4)*FRACUNIT
		slidedust.momy = P_RandomRange(-4, 4)*FRACUNIT
		slidedust.momz = P_RandomRange(0, 4)*FRACUNIT
		slidedust.destscale = -1
		player.mo.state = S_PLAY_MELEE
	end
	if not (S_SoundPlaying(player.mo,sfx_s3k7e))
	and player.pflags & PF_SPINNING
	and player.mo.skin == "legacysilver" then
		S_StartSound(player.mo, sfx_s3k7e)
	end
	if player.pflags & PF_SPINNING
	and not P_IsObjectOnGround(player.mo)
	and player.mo.skin == "legacysilver"
		player.mo.state = S_PLAY_SPRING
		player.pflags = $ & ~PF_SPINNING
	end
end)

	
addHook("PlayerThink", function(player)
	if not player and player.valid and player.mo.skin == "legacysilver" return end
	if player.pushcooldown == nil
		player.pushcooldown = 0
	end
	if player.landingtics == nil
		player.landingtics = 0
	end
	if (player.pushcooldown > 0)
	   player.pushcooldown = $1 - 1
	end
	if (player.landingtics > 0)
	   player.landingtics = $1 - 1
	end
	if player.cmd.buttons & BT_CUSTOM1
	and player.pushcooldown == 0
	and player.mo.skin == "legacysilver"
	and P_IsObjectOnGround(player.mo)
		player.mo.state = S_PLAY_GLIDE_LANDING
		player.landingtics = 20
		player.pushcooldown = 60 
		S_StartSound(player.mo, sfx_s3kc6s)
		P_Telekinesis(player, 70*FRACUNIT, 800*FRACUNIT)
		for i = 1,18
		local die = P_SPMAngle(player.mo,MT_THOK,player.mo.angle+(ANG20*i),1)
			die.colorized = true
			die.color = player.mo.color
			die.momz = 0
			P_InstaThrust(die,die.angle,50*FRACUNIT)
		end
	end
	if player.landingtics
		player.mo.state = S_PLAY_GLIDE_LANDING
		P_InstaThrust(player.mo, player.mo.angle, 0)
	end
	if player.landingtics == 0
	and player.mo.state == S_PLAY_GLIDE_LANDING
		player.mo.state = S_PLAY_WALK
	end
end)


addHook("PlayerThink", function(player)
	if not player and player.valid and player.mo.skin == "legacysilver" return end
	if player.justdashed == nil
		player.justdashed = 0
	end
	if player.floatdash == nil
		player.floatdash = 0
	end
	if player.fdtimer == nil
		player.fdtimer = 0
	end
	if (player.fdtimer > 0)
	   player.fdtimer = $1 - 1
	end
	if P_IsObjectOnGround(player.mo)
		player.justdashed = 0
		player.floatdash = 0
		player.fdtimer = 0
	end
	if player.cmd.buttons & BT_SPIN
	and player.mo.skin == "legacysilver"
	and player.mo.state == S_PLAY_FLOAT
	and player.justdashed == 0
	and not P_IsObjectOnGround(player.mo)
		player.justdashed = 1
		player.floatdash = 1
		player.fdtimer = 50
		S_StartSound(player.mo, sfx_cdfm01)
	end
	if player.cmd.buttons & BT_SPIN
	and player.mo.skin == "legacysilver"
	and player.mo.state == S_PLAY_FLOAT_RUN
	and player.justdashed == 0
	and not P_IsObjectOnGround(player.mo)
		player.justdashed = 1
		player.floatdash = 2
		player.fdtimer = 40
		S_StartSound(player.mo, sfx_cdfm01)
	end
	if player.floatdash == 1
	and player.fdtimer
		local floatghost = P_SpawnGhostMobj(player.mo)
		floatghost.fuse = 6
		floatghost.color = player.mo.color
		floatghost.colorized = true
		player.mo.state = S_PLAY_DASH
		P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT)
	end
	if player.fdtimer == 0
	and player.floatdash == 1
		player.floatdash = 0
	end
	if player.floatdash == 2
	and player.fdtimer
		local floatghost = P_SpawnGhostMobj(player.mo)
		floatghost.fuse = 6
		floatghost.color = player.mo.color
		floatghost.colorized = true
		player.mo.state = S_PLAY_DASH
		P_InstaThrust(player.mo, player.mo.angle, 36*FRACUNIT)
		P_SetObjectMomZ(player.mo, FRACUNIT*10)
	end
	if player.mo.state == S_PLAY_DASH
	and player.fdtimer == 0
		player.mo.state = S_PLAY_FLOAT
	end
	if player.fdtimer == 0
	and player.floatdash == 2
		player.floatdash = 0
	end
end)